-- Exit if oUF isn't loaded
if not oUF then return end

local Banzai = LibStub("LibBanzai-2.0", true); if not Banzai then return end

-- Values are: Red,  Green  Blue  Alpha
local agroColor =	{ 1, 0, 0, 1 }
local height = 3
local width = "Full"
local anchorFrom = "TOPLEFT"
local anchorRelative = "TOPLEFT"
local pingScale = .7
local pingDuration = 2

local function AgroHandler(aggro, unitName, ...)
	for unit in pairs(oUF.units) do
		if UnitName(unit) == unitName and not oUF.units[unit].ignoreAgroIndicator and not unit:find("target") then
			if aggro == 1 then
				-- Gain agro
				oUF.units[unit].AgroIndicator.vis:Show()
				if oUF.units[unit].AgroIndicator.vis.ping then
					local vis = oUF.units[unit].AgroIndicator.vis
					vis.ping:Show()
					vis.ping:SetAlpha(1)
					local endTime = GetTime() + pingDuration
					vis:SetScript("OnUpdate", function()
						if endTime < GetTime() then
							vis.ping:Hide()
							vis:SetScript("OnUpdate", nil)
						elseif endTime - 1 < GetTime() then
							vis.ping:SetAlpha( endTime - GetTime() )
						end
					end)
				end
			elseif aggro == 0 then
				-- Loose agro
				oUF.units[unit].AgroIndicator.vis:Hide()
			end
		end
	end
end

local function hook(frame)
	if frame.ignoreAgroIndicator or not frame.Health then return end
	
	if not frame.AgroIndicator then
		frame.AgroIndicator = { }
	end
	
	local f = CreateFrame("Frame")
	f:SetFrameLevel(frame:GetFrameLevel()+5) -- Allways on top of everything
	f:SetParent(frame)
	local indicator = f:CreateTexture( nil, "OVERLAY" )
	
	indicator:SetTexture(frame.AgroIndicator.texture or frame.Health:GetStatusBarTexture():GetTexture())
	indicator:SetVertexColor( unpack(frame.AgroIndicator.color or agroColor) )
	
	local w = frame.AgroIndicator.width or width
	local h = frame.AgroIndicator.height or height
	if w == "Full" then
		indicator:SetPoint("LEFT", frame.AgroIndicator.anchorTo or frame.Health, "LEFT")
		indicator:SetPoint("RIGHT", frame.AgroIndicator.anchorTo or frame.Health, "RIGHT")
	else
		indicator:SetWidth(w)
	end
	if h == "Full" then
		indicator:SetPoint("TOP", frame.AgroIndicator.anchorTo or frame.Health, "TOP")
		indicator:SetPoint("BOTTOM", frame.AgroIndicator.anchorTo or frame.Health, "BOTTOM")
	else
		indicator:SetHeight(h)
	end
	indicator:SetPoint(frame.AgroIndicator.anchorFrom or anchorFrom, frame.AgroIndicator.anchorTo or frame.Health,frame.AgroIndicator.anchorRelative or anchorRelative,frame.Health,frame.AgroIndicator.offsetX or 0,frame.AgroIndicator.offsetY or 0)

	local pingScale = frame.AgroIndicator.pingScale or pingScale
	
	if pingScale > 0 then
		f.ping = CreateFrame( "Model", nil, f )
		f.ping:SetModel( "Interface\\MiniMap\\Ping\\MinimapPing.mdx" )
		f.ping:SetModelScale( .5 )
		f.ping:SetHeight(50)
		f.ping:SetWidth(50)
		f.ping:SetPoint("CENTER", indicator, "CENTER")
		f.ping:SetPosition( 0.02, 0.02, 0 )
		f.ping:SetScale(pingScale)
		f.ping:Hide()
	end
	
	f:Hide()
	frame.AgroIndicator.vis = f
end

-- Append to all existing frames
for frame in pairs(oUF.objects) do hook(frame) end

-- Append to frames created later on
oUF:RegisterInitCallback(hook)

Banzai:RegisterCallback(AgroHandler)
