-- Requires oUF
if not oUF or not oUF.Smurf then return end

local unit = oUF.HolySmurf.Config.units
local groups = oUF.HolySmurf.Config.groups
----------------------------------------------------------------------------
-- 		Group spawning
----------------------------------------------------------------------------
local RaidMemberVerticalSpace = 18
local RaidMemberHorizontalSpace = 5
local RaidMarginTop = 25
local RaidPlayerTargetSpace = 5
local RaidMemberLeftMargin = 10

if unit.raid then
	table.insert(groups, {		-- Raid group 1
		name = "raidgroup1",
		children = "raid",
		
		anchorTo = "UIParent",
		anchorPoint = "TOPLEFT",
		anchorRelative = "TOPLEFT",
		anchorOffsetX = RaidMemberHorizontalSpace+RaidMemberLeftMargin,
		anchorOffsetY = -RaidMarginTop,
		
		manyAttributes = function() return "groupFilter", "1", "showRaid", true, "yOffSet", -RaidMemberVerticalSpace, "initial-scale", unit.raid.scale or 1 end
	})

	table.insert(groups, {		-- Raid group 5 anchors to Raid group 1
		name = "raidgroup5",
		children = "raid",
		
		anchorTo = "UIParent",
		anchorPoint = "TOPLEFT",
		anchorRelative = "TOPLEFT",
		anchorOffsetX = RaidMemberHorizontalSpace+RaidMemberLeftMargin,
		anchorOffsetY = function(self)
				local raidHeight = oUF.SmurfConfig.units.raid.height
				return -((RaidMemberVerticalSpace+raidHeight)*5+RaidMarginTop)
			end,
		
		manyAttributes = function() return "groupFilter", "5", "showRaid", true, "yOffSet", -RaidMemberVerticalSpace, "initial-scale", unit.raid.scale or 1 end
	})

	for i=2, 8 do
		if i ~= 5 then
			table.insert(groups, {		-- The rest of the raid groups anchors to i-1
				name = "raidgroup"..(i),
				children = "raid",
				
				anchorTo = "oUFSmurfraidgroup"..(i-1).."_raid",	 -- Name of a given frame: "oUFSmurf" .. name .. "_" .. children
				anchorPoint = "TOPLEFT",
				anchorRelative = "TOPRIGHT",
				anchorOffsetX = RaidMemberHorizontalSpace,
				anchorOffsetY = 0,
				
				manyAttributes = function() return "groupFilter", tostring(i), "showRaid", true, "yOffSet", -RaidMemberVerticalSpace, "initial-scale", unit.raid.scale or 1 end
			})
		end
	end
end

-- Player targets
if unit.raidplayertarget then
	table.insert(groups, {
		name = "raidplayertarget",
		children = "raidplayertarget", -- The unit type that spawns from this group
		
		anchorTo = "oUFSmurfraidgroup6_raid",
		anchorPoint = "TOPLEFT",
		anchorRelative = "BOTTOMLEFT",
		anchorOffsetX = oUF.SmurfConfig.units.raid.width,
		anchorOffsetY = -10,
		
		manyAttributes = function() return "nameList", "", "showRaid", true, "yOffSet", -RaidPlayerTargetSpace, "initial-scale", unit.raidplayertarget.scale or 1 end
	})
end

-- MTTargets
if unit.maintank then
	table.insert(groups, {
		name = "maintank",
		children = "maintank", -- The unit type that spawns from this group
		
		anchorTo = "oUFSmurfraidplayertarget_raidplayertarget",
		anchorPoint = "TOPLEFT",
		anchorRelative = "BOTTOMLEFT",
		anchorOffsetX = 0,
		anchorOffsetY = -5,
		
		manyAttributes = function() return "groupFilter", "MAINTANK", "showRaid", true, "yOffSet", -RaidPlayerTargetSpace, "initial-scale", unit.maintank.scale or 1 end
	})
end

-- MainAssist
if unit.mainassist then
	table.insert(groups, {
		name = "mainassist",
		children = "mainassist", -- The unit type that spawns from this group
		
		anchorTo = "oUFSmurfmaintank_maintank",
		anchorPoint = "TOPLEFT",
		anchorRelative = "BOTTOMLEFT",
		anchorOffsetX = 0,
		anchorOffsetY = -5,
		
		manyAttributes = function() return "groupFilter", "MAINASSIST", "showRaid", true, "yOffSet", -RaidPlayerTargetSpace, "initial-scale", unit.mainassist.scale or 1 end
	})
end

-- Party
if unit.party then
	table.insert(groups, {
		name = "party",
		children = "party", -- The unit type that spawns from this group
		
		anchorTo = "UIParent",
		anchorPoint = "TOPLEFT",
		anchorRelative = "TOPLEFT",
		anchorOffsetY = -130,
		anchorOffsetX = 5,

		manyAttributes = function() return "showParty", true, "showRaid", false, "showPlayer", true, "yOffSet", -45, "initial-scale", unit.party.scale or 1 end
	})
end
