-- Exit if oUF isn't loaded
if not oUF then return end

LoadAddOn("LibRangeCheck-2.0")
local updateEveryXFrame = 10 -- @ 30 FPS, update 3 times pr sec
local updateCount = -90 -- @ Hold updates for 1-3 sec
local RangeCheck = LibStub("LibRangeCheck-2.0")
if not RangeCheck then return false end
local objects = { }
local tinsert = tinsert

local rangeAlphaEnemy = nil
local rangeAlphaFriendly = nil

local e = CreateFrame("Frame", nil, UIParent)
local max
e:SetScript("OnUpdate", function()
	updateCount = updateCount + 1
	if updateCount < updateEveryXFrame then return end
	updateCount = 1

	for _,object in pairs(objects) do
		if object.unit and object:IsShown() then
			_, max = RangeCheck:getRange(object.unit, true)
			if (UnitCanAttack("player", object.unit)) then
				-- Enemy
				object:SetAlpha(rangeAlphaEnemy[max or 1000] or 1)
			elseif (UnitCanAssist("player", object.unit)) then
				-- Friend
				object:SetAlpha(rangeAlphaFriendly[max or 1000] or 1)
			else
				-- Something in between
				object:SetAlpha(rangeAlphaFriendly[max or 1000] or 1)
			end
		end
	end
end)

local hook = function(object)
	if not object.TargeRangeCheck then return end
	tinsert(objects, object)
	if not rangeAlphaEnemy then
		-- Init ranges / alpha table
		rangeAlphaEnemy = (oUF.RangeCheckConfig and oUF.RangeCheckConfig.rangeAlphaEnemy) or {
			[0] = 1,
			[31] = .3,
			[100] = .3,
			[1000] = .2,
		}
		rangeAlphaFriendly = (oUF.RangeCheckConfig and oUF.RangeCheckConfig.rangeAlphaFriendly) or {
			[0] = 1,
			[41] = .3,
			[100] = .3,
			[1000] = .2,
		}
		do
			-- Populate the rest of the table
			local rAE = rangeAlphaEnemy
			local rAF = rangeAlphaFriendly
			rAE[-1] = 1
			rAF[-1] = 1
			local max = 100
			for i=0, max do
				if not rAE[i] then rAE[i] = rAE[i-1] end
				if not rAF[i] then rAF[i] = rAF[i-1] end
			end
		end
	end
end

-- Append to all existing frames
for _,object in pairs(oUF.objects) do hook(object) end

-- Append to frames created later on
oUF:RegisterInitCallback(hook)
